﻿/// @file config.h
///
/// @brief 設定ファイル入出力
///
#ifndef _CONFIG_H_
#define _CONFIG_H_

#include "common.h"
#include <wx/wx.h>

/// 設定ファイル入出力
class Config
{
private:
	wxString ini_file;

	wxString mFilePath;
	int      mNewLineAscii;
	int      mNewLineUtf8;
	bool     mIncludeBOM;
	int      mStartAddr;
	wxString mFontName;
	int      mFontSize;

	void SetDefaultFontName();
public:
	Config();
	~Config();
	void SetFileName(const wxString &file);
	void Load(const wxString &file);
	void Load();
	void Save();

	/// @name properties
	//@{
	void SetFilePath(const wxString &val) { mFilePath = val; }
	void SetNewLineAscii(int val) { mNewLineAscii = val; }
	void SetNewLineUtf8(int val) { mNewLineUtf8 = val; }
	void SetIncludeBOM(bool val) { mIncludeBOM = val; }
	void SetStartAddr(int val) { mStartAddr = val; }
	void SetFontName(const wxString &val) { mFontName = val; }
	void SetFontSize(int val) { mFontSize = val; }
	wxString &GetFilePath() { return mFilePath; }
	int GetNewLineAscii() { return mNewLineAscii; }
	int GetNewLineUtf8() { return mNewLineUtf8; }
	bool GetIncludeBOM() { return mIncludeBOM; }
	int GetStartAddr() { return mStartAddr; }
	wxString &GetFontName() { return mFontName; }
	int GetFontSize() { return mFontSize; }
	//@}
};

#endif /* _CONFIG_H_ */
