﻿/// @file configbox.h
///
/// @brief 設定ダイアログ
///
#ifndef _CONFIGBOX_H_
#define _CONFIGBOX_H_

#include "common.h"
#include <wx/wx.h>
#include <wx/dialog.h>

/// 設定ダイアログ
class ConfigBox : public wxDialog
{
private:
	wxRadioButton *radNewLineAscii[3];
	wxRadioButton *radNewLineUtf8[3];
	wxCheckBox    *chkBom;
	wxComboBox    *comStartAddr;

	/// parameter
	//@{
	int mNewLineAscii;
	int mNewLineUtf8;
	bool mIncludeBOM;
	int mStartAddr;
	//@}

	void init_dialog();
	void term_dialog();

public:
	ConfigBox(wxWindow* parent, wxWindowID id);

	enum {
		IDC_RADIO_ASCII_CR = 1,
		IDC_RADIO_ASCII_LF,
		IDC_RADIO_ASCII_CRLF,
		IDC_RADIO_UTF8_CR,
		IDC_RADIO_UTF8_LF,
		IDC_RADIO_UTF8_CRLF,
		IDC_CHK_BOM,
		IDC_COMBO_STARTADDR,
	};

	/// functions
	//@{
	int ShowModal();
	void AddStartAddrItems(const int *items, size_t count);
	//@}

	/// event procedures

	/// properties
	//@{
	void SetNewLineAscii(int val) { mNewLineAscii = val; }
	void SetNewLineUtf8(int val) { mNewLineUtf8 = val; }
	void SetIncludeBOM(bool val) { mIncludeBOM = val; }
	void SetStartAddr(int val) { mStartAddr = val; }
	int GetNewLineAscii() { return mNewLineAscii; }
	int GetNewLineUtf8() { return mNewLineUtf8; }
	bool GetIncludeBOM() { return mIncludeBOM; }
	int GetStartAddr() { return mStartAddr; }
	//@}

	DECLARE_EVENT_TABLE()
};

#endif /* _CONFIGBOX_H_ */
